﻿using Syncfusion.UI.Xaml.Schedule;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace RefreshResource_SfSchedule_WinRT
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        
        ObservableCollection<ResourceType> _resourceCollection;
        public ObservableCollection<ResourceType> ResourceCollection
        {
            get { return _resourceCollection; }
            set
            {
                _resourceCollection = value;
            }
        }

        public MainPage()
        {
            this.InitializeComponent();
            this.DataContext = this;
            ResourceCollection = new ObservableCollection<ResourceType>();
            ResourceType _doctor = new ResourceType() { TypeName = "Doctor" };
            _doctor.ResourceCollection.Add(new Resource() { DisplayName = "Dr.Dexter Morgon", TypeName = "Doctor", ResourceName = "Dr.Dexter" });
            _doctor.ResourceCollection.Add(new Resource() { DisplayName = "Dr.Mercy Bishop", TypeName = "Doctor", ResourceName = "Dr.Mercy" });

            ResourceCollection.Add(_doctor);
            
            ScheduleAppointment _doctorAppointment1 = new ScheduleAppointment() { Subject = "Out Patients", StartTime = DateTime.Now.Date.AddHours(9), EndTime = DateTime.Now.Date.AddHours(11) };
            ScheduleAppointment _doctorAppointment2 = new ScheduleAppointment() { Subject = "Heart Operation", StartTime = DateTime.Now.Date.AddHours(8), EndTime = DateTime.Now.Date.AddHours(11) };

            _doctorAppointment1.ResourceCollection.Add(new Resource() { ResourceName = "Dr.Dexter", TypeName = "Doctor" });
            _doctorAppointment2.ResourceCollection.Add(new Resource() { ResourceName = "Dr.Mercy", TypeName = "Doctor" });

            this.schedule1.Appointments.Add(_doctorAppointment1);
            this.schedule1.Appointments.Add(_doctorAppointment2);

            this.schedule1.ScheduleResourceTypeCollection = ResourceCollection;
            this.schedule1.Resource = "Doctor";
            this.schedule1.DayHeaderOrder = DayHeaderOrder.OrderByDate;
        }
        
        private void ClearResource_Click_1(object sender, RoutedEventArgs e)
        {
            //To remove the resource 
            this.schedule1.Resource = string.Empty;
        }

        private void ClearAppointment_Click_1(object sender, RoutedEventArgs e)
        {
            //To Clear the Appointments
            this.schedule1.Appointments.Clear();
        }

        private void ResetResource_Click_1(object sender, RoutedEventArgs e)
        {
            
            ResourceType _coder = new ResourceType() { TypeName = "Coder" };
            _coder.ResourceCollection.Add(new Resource() { DisplayName = "John Smith", TypeName = "Coder", ResourceName = "John" });
            _coder.ResourceCollection.Add(new Resource() { DisplayName = "Peter Burke", TypeName = "Coder", ResourceName = "Peter" });
            ResourceCollection.Add(_coder);

            ScheduleAppointment _coderAppointment1 = new ScheduleAppointment() { Subject = "Complete Module A", StartTime = DateTime.Now.Date.AddHours(7), EndTime = DateTime.Now.Date.AddHours(9) };
            ScheduleAppointment _coderAppointment2 = new ScheduleAppointment() { Subject = "Review Module A", StartTime = DateTime.Now.Date.AddHours(6), EndTime = DateTime.Now.Date.AddHours(8) };
            _coderAppointment1.ResourceCollection.Add(new Resource() { ResourceName = "John", TypeName = "Coder" });
            _coderAppointment2.ResourceCollection.Add(new Resource() { ResourceName = "Peter", TypeName = "Coder" });
            this.schedule1.Appointments.Add(_coderAppointment1);
            this.schedule1.Appointments.Add(_coderAppointment2);

            //To reset the Resource Collection
            this.schedule1.ScheduleResourceTypeCollection = ResourceCollection;
            
            this.schedule1.Resource = "Coder";
        }
    }
}
